Index: loader.c
===================================================================
RCS file: /usr/cvsroot/asterisk/loader.c,v
retrieving revision 1.40
diff -u -r1.40 loader.c
--- loader.c	22 Apr 2005 13:11:34 -0000	1.40
+++ loader.c	25 May 2005 21:09:03 -0000
@@ -44,6 +44,9 @@
 { 0x8e, 0x93, 0x22, 0x83, 0xf5, 0xc3, 0xc0, 0x75,
   0xff, 0x8b, 0xa9, 0xbe, 0x7c, 0x43, 0x74, 0x63 };
 
+/*
+ * A module is described by this data structure.
+ */
 struct module {
 	int (*load_module)(void);
 	int (*unload_module)(void);
@@ -54,8 +57,43 @@
 	void *lib;
 	char resource[256];
 	struct module *next;
+
+	enum {	/* possible states of a module */
+		MS_NEW,			/* nothing known */
+		MS_RESOLVED,		/* all required resolved */
+		MS_CANLOAD,		/* as above, plus cyclic depend.*/
+		MS_ACTIVE,		/* all done */
+		MS_FAILED,		/* cannot load */
+	} status;
+	struct symbol_entry *required;
+	struct symbol_entry *es;
+	int export_refcount;	/* how many users of exported symbols */
 };
 
+/*
+ * helper routine to print the symbolic name associated to a state
+ */
+static const char *st_name(int status)
+{
+	/* try to resolve required symbols */
+	const char *st;
+	switch (status) {
+#define ST(x)	case x: st = # x; break;
+	ST(MS_NEW);
+	ST(MS_FAILED);
+	ST(MS_RESOLVED);
+	ST(MS_ACTIVE);
+	ST(MS_CANLOAD);
+	default: st = "unknown";
+	}
+	return st;
+#undef ST(x)
+}
+
+/*
+ * Routines to check that the key() returned by a module is
+ * what we expect.
+ */
 static int printdigest(unsigned char *d)
 {
 	int x;
@@ -73,12 +111,11 @@
 
 static int key_matches(char *key1, char *key2)
 {
-	int match = 1;
 	int x;
-	for (x=0;x<16;x++) {
-		match &= (key1[x] == key2[x]);
-	}
-	return match;
+	for (x=0;x<16;x++)
+		if (key1[x] != key2[x])
+			return 0;
+	return 1;
 }
 
 static int verify_key(char *key)
@@ -94,54 +131,145 @@
 	return -1;
 }
 
-static struct loadupdate {
-	int (*updater)(void);
-	struct loadupdate *next;
-} *updaters = NULL;
 
 AST_MUTEX_DEFINE_STATIC(modlock);
 AST_MUTEX_DEFINE_STATIC(reloadlock);
 
-static struct module *module_list=NULL;
+/*
+ * The list of modules.
+ */
+static struct module *ml_head=NULL;
+static struct module *ml_tail=NULL;
 static int modlistver = 0;
 
+/*
+ * append a module to the list.
+ * XXX watch out for recursive calls in m->load_module()
+ */
+static void module_append(struct module *m)
+{
+	m->next = NULL;
+	if (ml_head == NULL)
+		ml_head = m;
+	else
+		ml_tail->next = m;
+	ml_tail = m;
+}
+
+static struct module *find_module(const char *resource)
+{
+	struct module *m;
+	for (m = ml_head; m; m = m->next) {
+		if (!strcasecmp(resource, m->resource))
+			break;
+	}
+	return m;
+}
+
+/*
+ * Fetch/release an exported symbol - modify export_refcount by delta
+ * on success, and return symbol value.
+ * If src is non-NULL, non exit *src points to the module.
+ */
+static void *module_symbol_helper(const char *name,
+		int delta, struct module **src)
+{
+	void *ret = NULL;
+	struct module *m;
+	struct symbol_entry *es;
+
+	for (m = ml_head; m; m = m->next) {
+		/* cannot 'get' a symbole from a failed module */
+		if (delta > 0 && m->status == MS_FAILED)
+			continue;
+		for (es = m->es; ret == NULL && es && es->name; es++) {
+			if (!strcmp(es->name, name)) {
+				ret = es->value;
+				m->export_refcount += delta;
+				if (src)
+					*src = m;
+				break;
+			}
+		}
+		if (ret)
+			break;
+	}
+	if (ret == NULL)
+		ast_log(LOG_WARNING, "symbol %s not found\n", name);
+	return ret;
+}
+
+static void *release_module_symbol(const char *name)
+{
+	return module_symbol_helper(name, -1, NULL);
+}
+
+static void *get_module_symbol(const char *name, struct module **src)
+{
+	return module_symbol_helper(name, +1, src);
+}
+
+/*
+ * Helper function to release a module. Release refcounts to symbols
+ * imported, and change state to MS_FAILED.
+ */
+static void release_module(struct module *m)
+{
+	struct symbol_entry *s;
+	for (s = m->required; s && s->name != NULL; s++) {
+		if (s->value != NULL) {
+			release_module_symbol(s->name);
+			s->value = NULL;
+		}
+	}
+	m->status = MS_FAILED;
+}
+
+static struct loadupdate {
+	int (*updater)(void);
+	struct loadupdate *next;
+} *updaters = NULL;
+
+/*
+ * API functio to unload a resource.
+ * XXX check behaviour on recursive calls.
+ */
 int ast_unload_resource(const char *resource_name, int force)
 {
 	struct module *m, *ml = NULL;
 	int res = -1;
-	if (ast_mutex_lock(&modlock))
-		ast_log(LOG_WARNING, "Failed to lock\n");
-	m = module_list;
-	while(m) {
-		if (!strcasecmp(m->resource, resource_name)) {
-			if ((res = m->usecount()) > 0)  {
-				if (force) 
-					ast_log(LOG_WARNING, "Warning:  Forcing removal of module %s with use count %d\n", resource_name, res);
-				else {
-					ast_log(LOG_WARNING, "Soft unload failed, '%s' has use count %d\n", resource_name, res);
-					ast_mutex_unlock(&modlock);
-					return -1;
-				}
-			}
-			res = m->unload_module();
-			if (res) {
-				ast_log(LOG_WARNING, "Firm unload failed for %s\n", resource_name);
-				if (force <= AST_FORCE_FIRM) {
-					ast_mutex_unlock(&modlock);
-					return -1;
-				} else
-					ast_log(LOG_WARNING, "** Dangerous **: Unloading resource anyway, at user request\n");
+	ast_mutex_lock(&modlock);
+	for (ml = NULL, m = ml_head; m; ml = m, m = m->next) {
+		if (strcasecmp(m->resource, resource_name) != 0)
+			continue;
+		if ((res = m->usecount()) > 0)  {
+			if (force) 
+				ast_log(LOG_WARNING, "Warning:  Forcing removal of module %s with use count %d\n", resource_name, res);
+			else {
+				ast_log(LOG_WARNING, "Soft unload failed, '%s' has use count %d\n", resource_name, res);
+				ast_mutex_unlock(&modlock);
+				return -1;
 			}
-			if (ml)
-				ml->next = m->next;
-			else
-				module_list = m->next;
-			dlclose(m->lib);
-			free(m);
-			break;
 		}
-		ml = m;
-		m = m->next;
+		res = m->unload_module();
+		if (res) {
+			ast_log(LOG_WARNING, "Firm unload failed for %s\n", resource_name);
+			if (force <= AST_FORCE_FIRM) {
+				ast_mutex_unlock(&modlock);
+				return -1;
+			} else
+				ast_log(LOG_WARNING, "** Dangerous **: Unloading resource anyway, at user request\n");
+		}
+		release_module(m);
+		if (ml)
+			ml->next = m->next;
+		else
+			ml_head = m->next;
+		if (ml_tail == m)
+			ml_tail = ml;
+		dlclose(m->lib);
+		free(m);
+		break;
 	}
 	modlistver = rand();
 	ast_mutex_unlock(&modlock);
@@ -149,7 +277,12 @@
 	return res;
 }
 
-char *ast_module_helper(char *line, char *word, int pos, int state, int rpos, int needsreload)
+/*
+ * Helper function used by the cli to do something on modules
+ * XXX what ?
+ */
+char *ast_module_helper(char *line, char *word, int pos, int state,
+	int rpos, int needsreload)
 {
 	struct module *m;
 	int which=0;
@@ -157,13 +290,11 @@
 	if (pos != rpos)
 		return NULL;
 	ast_mutex_lock(&modlock);
-	m = module_list;
-	while(m) {
+	for (m = ml_head; m; m = m->next) {
 		if (!strncasecmp(word, m->resource, strlen(word)) && (m->reload || !needsreload)) {
 			if (++which > state)
 				break;
 		}
-		m = m->next;
 	}
 	if (m) {
 		ret = strdup(m->resource);
@@ -193,7 +324,6 @@
 	struct module *m;
 	int reloaded = 0;
 	int oldversion;
-	int (*reload)(void);
 	/* We'll do the logger and manager the favor of calling its reload here first */
 
 	if (ast_mutex_trylock(&reloadlock)) {
@@ -224,339 +354,403 @@
 
 	ast_mutex_lock(&modlock);
 	oldversion = modlistver;
-	m = module_list;
-	while(m) {
+	for (m = ml_head; m; m = m->next) {
 		if (!name || !strcasecmp(name, m->resource)) {
 			if (reloaded < 1)
 				reloaded = 1;
-			reload = m->reload;
 			ast_mutex_unlock(&modlock);
-			if (reload) {
+			if (m->reload) {
 				reloaded = 2;
 				if (option_verbose > 2) 
 					ast_verbose(VERBOSE_PREFIX_3 "Reloading module '%s' (%s)\n", m->resource, m->description());
-				reload();
+				m->reload();
 			}
 			ast_mutex_lock(&modlock);
 			if (oldversion != modlistver)
 				break;
 		}
-		m = m->next;
 	}
 	ast_mutex_unlock(&modlock);
 	ast_mutex_unlock(&reloadlock);
 	return reloaded;
 }
 
-static int __load_resource(const char *resource_name, const struct ast_config *cfg)
+/*
+ * lookup a symbol with or without leading '_'
+ * accept either form
+ */
+static void *find_symbol(struct module *m, char *name, int verbose)
+{
+	int l = strlen(name);
+	char *n1 = alloca(l+2); /* room for leading '_' and final '\0' */
+	void *s;
+
+	n1[0] = '_';
+	strcpy((name[0] == '_') ? n1 : n1+1, name);
+ 	s = dlsym(m->lib, n1+1);	/* try without '_' */
+	if (s == NULL)
+		s = dlsym(m->lib, n1);
+	if (verbose && s == NULL)
+		ast_log(LOG_WARNING, "No symbol '%s' in module '%s\n",
+			n1, m->resource);
+	return s;
+}
+
+/*
+ * Find or initialize the record for the resource
+ */
+static struct module * __load_resource(const char *name, int verbose)
 {
 	static char fn[256];
 	int errors=0;
-	int res;
-	struct module *m;
-	int flags=RTLD_NOW;
-#ifdef RTLD_GLOBAL
-	char *val;
-#endif
-	char *key;
+	struct module *m = NULL;
+	char *key = NULL;
 	char tmp[80];
 
-	if (strncasecmp(resource_name, "res_", 4)) {
-#ifdef RTLD_GLOBAL
-		if (cfg) {
-			if ((val = ast_variable_retrieve(cfg, "global", resource_name))
-					&& ast_true(val))
-				flags |= RTLD_GLOBAL;
+	if (verbose) {
+		if (option_debug && !option_verbose)
+			ast_log(LOG_DEBUG, "Loading module %s\n", name);
+		if (option_verbose) {
+			ast_verbose(VERBOSE_PREFIX_1 "[%s]",
+				term_color(tmp, name, COLOR_BRWHITE, 0, sizeof(tmp)));
+			fflush(stdout);
 		}
-#endif
-	} else {
-		/* Resource modules are always loaded global and lazy */
-#ifdef RTLD_GLOBAL
-		flags = (RTLD_GLOBAL | RTLD_LAZY);
-#else
-		flags = RTLD_LAZY;
-#endif
-	}
-	
-	if (ast_mutex_lock(&modlock))
-		ast_log(LOG_WARNING, "Failed to lock\n");
-	m = module_list;
-	while(m) {
-		if (!strcasecmp(m->resource, resource_name)) {
-			ast_log(LOG_WARNING, "Module '%s' already exists\n", resource_name);
-			ast_mutex_unlock(&modlock);
-			return -1;
-		}
-		m = m->next;
+	}
+
+	m = find_module(name);
+	if (m) { /* not fatal, already in the list */
+		ast_mutex_unlock(&modlock);
+		return m;
 	}
 	m = malloc(sizeof(struct module));	
 	if (!m) {
 		ast_log(LOG_WARNING, "Out of memory\n");
-		ast_mutex_unlock(&modlock);
-		return -1;
+		goto done;
 	}
-	strncpy(m->resource, resource_name, sizeof(m->resource)-1);
-	if (resource_name[0] == '/') {
-		strncpy(fn, resource_name, sizeof(fn)-1);
+	m->status = MS_NEW;
+	strncpy(m->resource, name, sizeof(m->resource)-1);
+	if (name[0] == '/') {
+		strncpy(fn, name, sizeof(fn)-1);
 	} else {
-		snprintf(fn, sizeof(fn), "%s/%s", (char *)ast_config_AST_MODULE_DIR, resource_name);
+		snprintf(fn, sizeof(fn), "%s/%s", (char *)ast_config_AST_MODULE_DIR, name);
 	}
-	m->lib = dlopen(fn, flags);
+	m->lib = dlopen(fn, RTLD_NOW | RTLD_LOCAL);
 	if (!m->lib) {
 		ast_log(LOG_WARNING, "%s\n", dlerror());
-		free(m);
-		ast_mutex_unlock(&modlock);
-		return -1;
+		goto done;
 	}
-	m->load_module = dlsym(m->lib, "load_module");
+
+	/*
+	 * Find all symbols required by the API
+	 * XXX in the future, just one struct
+	 */
+	m->load_module = find_symbol(m, "load_module", 1);
 	if (m->load_module == NULL)
-		m->load_module = dlsym(m->lib, "_load_module");
-	if (!m->load_module) {
-		ast_log(LOG_WARNING, "No load_module in module %s\n", fn);
 		errors++;
-	}
-	m->unload_module = dlsym(m->lib, "unload_module");
+	m->unload_module = find_symbol(m, "unload_module", 1);
 	if (m->unload_module == NULL)
-		m->unload_module = dlsym(m->lib, "_unload_module");
-	if (!m->unload_module) {
-		ast_log(LOG_WARNING, "No unload_module in module %s\n", fn);
 		errors++;
-	}
-	m->usecount = dlsym(m->lib, "usecount");
-	if (m->usecount == NULL)
-		m->usecount = dlsym(m->lib, "_usecount");
-	if (!m->usecount) {
-		ast_log(LOG_WARNING, "No usecount in module %s\n", fn);
+	m->usecount = find_symbol(m, "usecount", 1);
+	if (!m->usecount)
 		errors++;
-	}
-	m->description = dlsym(m->lib, "description");
+	m->description = find_symbol(m, "description", 1);
 	if (m->description == NULL)
-		m->description = dlsym(m->lib, "_description");
-	if (!m->description) {
-		ast_log(LOG_WARNING, "No description in module %s\n", fn);
 		errors++;
-	}
-	m->key = dlsym(m->lib, "key");
+	m->key = find_symbol(m, "key", 1);
 	if (m->key == NULL)
-		m->key = dlsym(m->lib, "_key");
-	if (!m->key) {
-		ast_log(LOG_WARNING, "No key routine in module %s\n", fn);
 		errors++;
-	}
-	m->reload = dlsym(m->lib, "reload");
-	if (m->reload == NULL)
-		m->reload = dlsym(m->lib, "_reload");
+	m->reload = find_symbol(m, "reload", 0); /* this is optional */
 	if (!m->key || !(key = m->key())) {
 		ast_log(LOG_WARNING, "Key routine returned NULL in module %s\n", fn);
-		key = NULL;
 		errors++;
 	}
 	if (key && verify_key(key)) {
 		ast_log(LOG_WARNING, "Unexpected key returned by module %s\n", fn);
 		errors++;
 	}
+	m->es = find_symbol(m, "exported_symbols", 0);
+	if (m->es) {	/* check that no NULL symbols are exported */
+		struct symbol_entry *es;
+		ast_log(LOG_WARNING, "module %s exports the following symbols\n",
+				name);
+		for (es = m->es; es->name; es++) {
+			void **p = es->value;
+			int i;
+
+			ast_log(LOG_WARNING, "\taddr %p size %8d %s\n",
+				es->value, es->size, es->name);
+			for (i = 0; i <  es->size / sizeof(void *); i++, p++) {
+				if (*p == NULL) {
+					ast_log(LOG_WARNING, "\t *** null field at offset %d\n", i);
+					errors++;
+				}
+			}
+		}
+	}
+	m->required = find_symbol(m, "required_symbols", 0);
 	if (errors) {
-		ast_log(LOG_WARNING, "%d error(s) loading module %s, aborted\n", errors, fn);
+		ast_log(LOG_WARNING, "%d error(s) loading module %s, aborted\n",
+			errors, fn);
 		dlclose(m->lib);
-		free(m);
-		ast_mutex_unlock(&modlock);
-		return -1;
+		goto done;
 	}
 	if (!fully_booted) {
 		if (option_verbose) 
-			ast_verbose( " => (%s)\n", term_color(tmp, m->description(), COLOR_BROWN, COLOR_BLACK, sizeof(tmp)));
+			ast_verbose(" => (%s)\n",
+				term_color(tmp, m->description(),
+					COLOR_BROWN, COLOR_BLACK, sizeof(tmp)));
 		if (option_console && !option_verbose)
-			ast_verbose( ".");
+			ast_verbose(".");
 	} else {
 		if (option_verbose)
-			ast_verbose(VERBOSE_PREFIX_1 "Loaded %s => (%s)\n", fn, m->description());
+			ast_verbose(VERBOSE_PREFIX_1 "Loaded %s => (%s)\n",
+				fn, m->description());
 	}
-
-	/* add module 'm' to end of module_list chain
-  	   so reload commands will be issued in same order modules were loaded */
-	m->next = NULL;
-	if (module_list == NULL) {
-		/* empty list so far, add at front */
-		module_list = m;
-	}
-	else {
-		struct module *i;
-		/* find end of chain, and add there */
-		for (i = module_list; i->next; i = i->next)
-			;
-		i->next = m;
-	}
-	
+	module_append(m);
 	modlistver = rand();
-	ast_mutex_unlock(&modlock);
-	if ((res = m->load_module())) {
-		ast_log(LOG_WARNING, "%s: load_module failed, returning %d\n", m->resource, res);
-		ast_unload_resource(resource_name, 0);
-		return -1;
-	}
-	ast_update_use_count();
 	return 0;
+
+done:
+	if (m)
+		free(m);
+	if (verbose)
+		ast_log(LOG_WARNING, "Loading module %s failed!\n", name);
+	return NULL;
 }
 
-int ast_load_resource(const char *resource_name)
-{
-	int o;
-	struct ast_config *cfg = NULL;
-	int res;
-
-	/* Keep the module file parsing silent */
-	o = option_verbose;
-	option_verbose = 0;
-	cfg = ast_config_load(AST_MODULE_CONFIG);
-	option_verbose = o;
-	res = __load_resource(resource_name, cfg);
-	if (cfg)
-		ast_config_destroy(cfg);
-	return res;
-}	
 
-static int ast_resource_exists(char *resource)
+/*
+ * Resolve symbols and determine if the suppliers are in MS_ACTIVE
+ * Return true if can try loading (i.e. all suppliers are MS_ACTIVE,
+ * or the module is in MS_CANLOAD meaning a cyclic dependency).
+ * Release the module if a symbol cannot be resolved or the supplier
+ * is in MS_FAILED
+ */
+static int resolve(struct module *m)
 {
-	struct module *m;
-	if (ast_mutex_lock(&modlock))
-		ast_log(LOG_WARNING, "Failed to lock\n");
-	m = module_list;
-	while(m) {
-		if (!strcasecmp(resource, m->resource))
+	int canload = 1;
+	struct symbol_entry *s;
+
+	if (m->status == MS_FAILED || m->status == MS_ACTIVE)
+		return 0;
+	if (m->status == MS_CANLOAD)
+		return 1;
+	/* resolve missing symbols, or verify existing ones */
+	for (s = m->required; s && s->name != NULL; s++) {
+		void **p = (void **)(s->value);
+
+		if (*p == NULL)
+			*p = get_module_symbol(s->name, &s->src);
+		if (*p == NULL || s->src->status == MS_FAILED) {	/* fail */
+			ast_log(LOG_WARNING,
+						"Failed symbol %s for module %s\n",
+						s->name, m->resource);
+			release_module(m);
 			break;
-		m = m->next;
+		}
+		if (s->src->status != MS_ACTIVE)
+			canload = 0;
 	}
-	ast_mutex_unlock(&modlock);
-	if (m)
-		return -1;
-	else
-		return 0;
+	return canload;
 }
 
-static const char *loadorder[] =
+/*
+ * Fixup references and load modules according to their dependency order.
+ * Called when new modules are added to the list.
+ * The algorithm is as follows:
+ * - all modules MS_FAILED are changed to MS_NEW, in case something
+ *	 happened that could help them.
+ * - first try to resolve symbols. If successful, change the
+ *   module's state to MS_RESOLVED otherwise to MS_FAILED
+ * - repeat on all modules until there is progress:
+ *    . if it is MS_ACTIVE or MS_FAILED, continue (no progress)
+ *    . if one has all required modules in MS_ACTIVE, try to load it.
+ *      If successful it becomes MS_ACTIVE itself, otherwise
+ *		MS_FAILED and releases all symbols.
+ *		In any case, we have progress.
+ *    . if one of the dependencies is MS_FAILED, release and set to
+ *      MS_FAILED here too. We have progress.
+ * - if we have no progress there is a cyclic dependency.
+ *	 Take first and change to MS_CANLOAD, i.e. as if all required are
+ *	 MS_ACTIVE. we have progress, so repeat.
+ * NOTE:
+ *   must be called with lock held
+ *   recursive calls simply return success.
+ */
+static int fixup(const char *caller)
 {
-	"res_",
-	"chan_",
-	"pbx_",
-	NULL,
-};
+	struct module *m;
+	int total, new, cycle;
+	static int in_fixup = 0;	/* disable recursive calls */
+
+	if (in_fixup)
+		return 0;
+	in_fixup++;
+	total = 0;
+	new = 0;
+	for (m = ml_head; m; m = m->next) {
+		total++;
+		if (m->status == MS_FAILED)
+			m->status = MS_NEW;
+		if (m->status == MS_NEW)
+			new++;
+		if (m->status == MS_NEW && (m->es || m->required))	/* diagnostic */
+			ast_log(LOG_WARNING,
+				"module %-30s exports %p requires %p status %d\n",
+				m->resource, m->es, m->required, m->status);
+	}
+	ast_log(LOG_WARNING, "---- fixup (%s): %d modules, %d new ---\n",
+		caller, total, new);
+	for (cycle = 0;;cycle++) {
+		int progress = 0;
+
+		ast_log(LOG_WARNING, "---- fixup: cycle %d ---\n", cycle);
+		for (m = ml_head; m; m = m->next) {
+			int canload = resolve(m);
+			if (canload || m->status == MS_NEW)
+				progress = 1;
+			if (canload) {
+				if (m->load_module()) {	/* error */
+					ast_log(LOG_WARNING, "load_module %s fail\n",
+						m->resource);
+					release_module(m);
+				} else {
+					ast_log(LOG_WARNING, "load_module %s success\n",
+						m->resource);
+					m->status = MS_ACTIVE;
+				}
+			}
+		}
+		if (!progress) {
+			/* resolve cyclic dependencies. Set one to MS_CANLOAD and repeat */
+			for (m = ml_head; m; m = m->next) {
+				if (m->status == MS_RESOLVED) {
+					m->status = MS_CANLOAD;
+					progress = 1;
+					break;
+				}
+			}
+			if (!progress)
+				break;
+		}
+	}
+	ast_log(LOG_WARNING, "---- fixup complete ---\n");
+	in_fixup--;
+	return 0;
+}
 
+/*
+ * load all modules from a configuration
+ */
 int load_modules()
 {
 	struct ast_config *cfg;
 	struct ast_variable *v;
-	char tmp[80];
+	DIR *mods = NULL;
+	struct dirent *d;
+
 	if (option_verbose) 
 		ast_verbose( "Asterisk Dynamic Loader Starting:\n");
 	cfg = ast_config_load(AST_MODULE_CONFIG);
+	ast_mutex_lock(&modlock);
 	if (cfg) {
 		/* Load explicitly defined modules */
-		v = ast_variable_browse(cfg, "modules");
-		while(v) {
-			if (!strcasecmp(v->name, "load")) {
-				if (option_debug && !option_verbose)
-					ast_log(LOG_DEBUG, "Loading module %s\n", v->value);
-				if (option_verbose) {
-					ast_verbose( VERBOSE_PREFIX_1 "[%s]", term_color(tmp, v->value, COLOR_BRWHITE, 0, sizeof(tmp)));
-					fflush(stdout);
-				}
-				if (__load_resource(v->value, cfg)) {
-					ast_log(LOG_WARNING, "Loading module %s failed!\n", v->value);
-					if (cfg)
-						ast_config_destroy(cfg);
-					return -1;
-				}
-			}
-			v=v->next;
+		if (option_verbose) 
+			ast_verbose( "Load Explicit Modules:\n");
+		for (v = ast_variable_browse(cfg, "modules"); v; v = v->next) {
+			if (strcasecmp(v->name, "load") != 0)
+				continue;
+			__load_resource(v->value, 1 /* verbose */);
 		}
 	}
 	if (!cfg || ast_true(ast_variable_retrieve(cfg, "modules", "autoload"))) {
-		/* Load all modules */
-		DIR *mods;
-		struct dirent *d;
-		int x;
-		/* Loop through each order */
-		for (x=0;x<sizeof(loadorder) / sizeof(loadorder[0]);x++) {
-			mods = opendir((char *)ast_config_AST_MODULE_DIR);
-			if (mods) {
-				while((d = readdir(mods))) {
-					/* Must end in .so to load it.  */
-					if ((strlen(d->d_name) > 3) && 
-					    (!loadorder[x] || !strncasecmp(d->d_name, loadorder[x], strlen(loadorder[x]))) && 
-					    !strcasecmp(d->d_name + strlen(d->d_name) - 3, ".so") &&
-						!ast_resource_exists(d->d_name)) {
-						/* It's a shared library -- Just be sure we're allowed to load it -- kinda
-						   an inefficient way to do it, but oh well. */
-						if (cfg) {
-							v = ast_variable_browse(cfg, "modules");
-							while(v) {
-								if (!strcasecmp(v->name, "noload") &&
-								    !strcasecmp(v->value, d->d_name)) 
-									break;
-								v = v->next;
-							}
-							if (v) {
-								if (option_verbose) {
-									ast_verbose( VERBOSE_PREFIX_1 "[skipping %s]\n", d->d_name);
-									fflush(stdout);
-								}
-								continue;
-							}
-							
-						}
-					    if (option_debug && !option_verbose)
-							ast_log(LOG_DEBUG, "Loading module %s\n", d->d_name);
-						if (option_verbose) {
-							ast_verbose( VERBOSE_PREFIX_1 "[%s]", term_color(tmp, d->d_name, COLOR_BRWHITE, 0, sizeof(tmp)));
-							fflush(stdout);
-						}
-						if (__load_resource(d->d_name, cfg)) {
-							ast_log(LOG_WARNING, "Loading module %s failed!\n", d->d_name);
-							if (cfg)
-								ast_config_destroy(cfg);
-							return -1;
-						}
+		mods = opendir((char *)ast_config_AST_MODULE_DIR);
+		if (mods == NULL) {
+			if (!option_quiet)
+				ast_log(LOG_WARNING, "Unable to open modules directory %s.\n",
+					ast_config_AST_MODULE_DIR);
+			
+		}
+	}
+	if (mods) {
+		while((d = readdir(mods))) {
+			/* Must end in .so to load it.  */
+			int want;
+
+			want = strlen(d->d_name) > 3 && 
+					!strcasecmp(d->d_name + strlen(d->d_name) - 3, ".so") &&
+					!find_module(d->d_name);
+				
+			if (!want)
+				continue;
+
+			/* It's a shared library --
+			 * Just be sure we're allowed to load it -- kinda
+			 * an inefficient way to do it, but oh well. */
+			if (cfg) {
+				for (v = ast_variable_browse(cfg, "modules");v; v = v->next) {
+					if (!strcasecmp(v->name, "noload") &&
+							!strcasecmp(v->value, d->d_name)) 
+						break;
+				}
+				if (v) {
+					if (option_verbose) {
+						ast_verbose( VERBOSE_PREFIX_1 "[skipping %s]\n",
+							d->d_name);
+						fflush(stdout);
 					}
+					continue;
 				}
-				closedir(mods);
-			} else {
-				if (!option_quiet)
-					ast_log(LOG_WARNING, "Unable to open modules directory %s.\n", (char *)ast_config_AST_MODULE_DIR);
 			}
+			__load_resource(d->d_name, 1 /* verbose */);
 		}
+		closedir(mods);
 	} 
-	ast_config_destroy(cfg);
+	fixup("load_modules");
+	ast_mutex_unlock(&modlock);
+	if (cfg)
+		ast_config_destroy(cfg);
 	return 0;
 }
 
+/*
+ * load a single module (API call).
+ * (recursive calls from load_module() succeed.
+ */
+int ast_load_resource(const char *resource_name)
+{
+	struct module *m;
+	int ret;
+
+	ast_mutex_unlock(&modlock);
+	m = __load_resource(resource_name, 0);
+	fixup(resource_name);
+	ret = (m->status == MS_FAILED) ? -1 : 0;
+	ast_mutex_unlock(&modlock);
+	return ret;
+}	
+
 void ast_update_use_count(void)
 {
 	/* Notify any module monitors that the use count for a 
 	   resource has changed */
 	struct loadupdate *m;
-	if (ast_mutex_lock(&modlock))
-		ast_log(LOG_WARNING, "Failed to lock\n");
-	m = updaters;
-	while(m) {
+	ast_mutex_lock(&modlock);
+	for (m = updaters; m ; m = m->next)
 		m->updater();
-		m = m->next;
-	}
 	ast_mutex_unlock(&modlock);
-	
 }
 
-int ast_update_module_list(int (*modentry)(char *module, char *description, int usecnt, char *like), char *like)
+int ast_update_module_list(int (*modentry)(char *module,
+		char *description, int usecnt, char *like), char *like)
 {
 	struct module *m;
-	int unlock = -1;
-	int total_mod_loaded = 0;
-	if (ast_mutex_trylock(&modlock))
-		unlock = 0;
-	m = module_list;
-	while(m) {
-		total_mod_loaded += modentry(m->resource, m->description(), m->usecount(), like);
-		m = m->next;
-	}
+	int unlock, total_mod_loaded = 0;
+
+	unlock = ast_mutex_trylock(&modlock) ? 0 : 1;
+	for (m = ml_head; m; m = m->next)
+		total_mod_loaded += modentry(m->resource,
+				m->description(), m->usecount(), like);
 	if (unlock)
 		ast_mutex_unlock(&modlock);
 	return total_mod_loaded;
@@ -566,38 +760,32 @@
 {
 	struct loadupdate *tmp;
 	/* XXX Should be more flexible here, taking > 1 verboser XXX */
-	if ((tmp = malloc(sizeof (struct loadupdate)))) {
-		tmp->updater = v;
-		if (ast_mutex_lock(&modlock))
-			ast_log(LOG_WARNING, "Failed to lock\n");
-		tmp->next = updaters;
-		updaters = tmp;
-		ast_mutex_unlock(&modlock);
-		return 0;
-	}
-	return -1;
+	tmp = malloc(sizeof (struct loadupdate));
+	if (tmp == NULL)
+		return -1;
+	tmp->updater = v;
+	ast_mutex_lock(&modlock);
+	tmp->next = updaters;
+	updaters = tmp;
+	ast_mutex_unlock(&modlock);
+	return 0;
 }
 
 int ast_loader_unregister(int (*v)(void))
 {
-	int res = -1;
-	struct loadupdate *tmp, *tmpl=NULL;
-	if (ast_mutex_lock(&modlock))
-		ast_log(LOG_WARNING, "Failed to lock\n");
-	tmp = updaters;
-	while(tmp) {
-		if (tmp->updater == v)	{
-			if (tmpl)
-				tmpl->next = tmp->next;
+	struct loadupdate *u, *pu;
+
+	ast_mutex_lock(&modlock);
+	for (pu = NULL, u = updaters; pu; pu = u, u = u->next) {
+		if (u->updater == v)	{
+			if (pu)
+				pu->next = u->next;
 			else
-				updaters = tmp->next;
+				updaters = u->next;
 			break;
 		}
-		tmpl = tmp;
-		tmp = tmp->next;
 	}
-	if (tmp)
-		res = 0;
 	ast_mutex_unlock(&modlock);
-	return res;
+	return (u ? 0 : -1);
 }
+/* end of file */
Index: apps/app_adsiprog.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_adsiprog.c,v
retrieving revision 1.10
diff -u -r1.10 app_adsiprog.c
--- apps/app_adsiprog.c	21 Apr 2005 06:02:43 -0000	1.10
+++ apps/app_adsiprog.c	25 May 2005 21:09:05 -0000
@@ -39,6 +39,13 @@
 
 static char *synopsis = "Load Asterisk ADSI Scripts into phone";
 
+static struct adsi_services *adsi;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(adsi),
+        { NULL, NULL }
+};
+
+
 /* #define DUMP_MESSAGES */
 
 static char *descrip =
@@ -1432,11 +1439,11 @@
 		return -1;
 
 	/* Start an empty ADSI Session */
-	if (adsi_load_session(chan, NULL, 0, 1) < 1) 
+	if (adsi->load_session(chan, NULL, 0, 1) < 1) 
 		return -1;
 
 	/* Now begin the download attempt */
-	if (adsi_begin_download(chan, scr->desc, scr->fdn, scr->sec, scr->ver)) {
+	if (adsi->begin_download(chan, scr->desc, scr->fdn, scr->sec, scr->ver)) {
 		/* User rejected us for some reason */
 		if (option_verbose > 2)
 			ast_verbose(VERBOSE_PREFIX_3 "User rejected download attempt\n");
@@ -1450,7 +1457,7 @@
 	for (x=0;x<scr->numkeys;x++) {
 		if (bytes + scr->keys[x].retstrlen > 253) {
 			/* Send what we've collected so far */
-			if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+			if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 				ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 				return -1;
 			}
@@ -1463,7 +1470,7 @@
 #endif
 	}
 	if (bytes) {
-		if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+		if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 			ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 			return -1;
 		}
@@ -1474,7 +1481,7 @@
 	for (x=0;x<scr->numdisplays;x++) {
 		if (bytes + scr->displays[x].datalen > 253) {
 			/* Send what we've collected so far */
-			if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+			if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 				ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 				return -1;
 			}
@@ -1487,7 +1494,7 @@
 #endif
 	}
 	if (bytes) {
-		if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+		if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 			ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 			return -1;
 		}
@@ -1498,7 +1505,7 @@
 	for (x=0;x<scr->numsubs;x++) {
 		if (bytes + scr->subs[x].datalen > 253) {
 			/* Send what we've collected so far */
-			if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+			if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 				ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 				return -1;
 			}
@@ -1511,7 +1518,7 @@
 #endif
 	}
 	if (bytes) {
-		if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
+		if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DOWNLOAD)) {
 			ast_log(LOG_WARNING, "Unable to send chunk ending at %d\n", x);
 			return -1;
 		}
@@ -1519,11 +1526,11 @@
 
 
 	bytes = 0;
-	bytes += adsi_display(buf, ADSI_INFO_PAGE, 1, ADSI_JUST_LEFT, 0, "Download complete.", "");
-	bytes += adsi_set_line(buf, ADSI_INFO_PAGE, 1);
-	if (adsi_transmit_message(chan, buf, bytes, ADSI_MSG_DISPLAY) < 0)
+	bytes += adsi->display(buf, ADSI_INFO_PAGE, 1, ADSI_JUST_LEFT, 0, "Download complete.", "");
+	bytes += adsi->set_line(buf, ADSI_INFO_PAGE, 1);
+	if (adsi->transmit_message(chan, buf, bytes, ADSI_MSG_DISPLAY) < 0)
 		return -1;
-	if (adsi_end_download(chan)) {
+	if (adsi->end_download(chan)) {
 		/* Download failed for some reason */
 		if (option_verbose > 2)
 			ast_verbose(VERBOSE_PREFIX_3 "Download attempt failed\n");
@@ -1532,7 +1539,7 @@
 		return -1;
 	}
 	free(scr);
-	adsi_unload_session(chan);
+	adsi->unload_session(chan);
 	return 0;
 }
 
@@ -1543,7 +1550,7 @@
 	if (!data || ast_strlen_zero(data))
 		data = "asterisk.adsi";
 	LOCAL_USER_ADD(u);
-	if (!adsi_available(chan)) {
+	if (!adsi->available(chan)) {
 		if (option_verbose > 2)
 			ast_verbose(VERBOSE_PREFIX_3 "ADSI Unavailable on CPE.  Not bothering to try.\n");
 	} else {
Index: apps/app_dial.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_dial.c,v
retrieving revision 1.153
diff -u -r1.153 app_dial.c
--- apps/app_dial.c	16 May 2005 00:09:09 -0000	1.153
+++ apps/app_dial.c	25 May 2005 21:09:06 -0000
@@ -38,6 +38,12 @@
 #include <sys/signal.h>
 #include <netinet/in.h>
 
+static struct ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_features),
+        { NULL, NULL }
+};
+
 static char *tdesc = "Dialing Application";
 
 static char *app = "Dial";
@@ -1320,7 +1326,7 @@
 				ast_hangup(peer);
 				return -1;
 			}
-			res = ast_bridge_call(chan,peer,&config);
+			res = ast_features->ast_bridge_call(chan,peer,&config);
 			time(&end_time);
 			snprintf(toast, sizeof(toast), "%ld", (long)(end_time - start_time));
 			pbx_builtin_setvar_helper(chan, "DIALEDTIME", toast);
